
import { _decorator, Component, Node, EventTouch } from 'cc';
const { ccclass, property } = _decorator;

import ship01 from "./ship01";

/**
 * Predefined variables
 * Name = NewComponent
 * DateTime = Wed Dec 01 2021 16:55:13 GMT+0800 (中国标准时间)
 * Author = 阿拉灯小火柴
 * FileBasename = NewComponent.ts
 * FileBasenameNoExtension = NewComponent
 * URL = db://assets/NewComponent.ts
 * ManualUrl = https://docs.cocos.com/creator/3.3/manual/zh/
 *
 */
var self = null;

@ccclass('ship_go')
export class ship_go extends Component {
    @property({ tooltip: "船脚本", type: ship01 })
    ship_js: ship01 = null!;



    onLoad() {

        this.node.on(Node.EventType.TOUCH_START, this.on_touch_s, this);
        this.node.on(Node.EventType.TOUCH_END, this.on_touch_off, this);
        this.node.on(Node.EventType.TOUCH_CANCEL, this.on_touch_off, this);
    }

    start() {
        // [3]
    }

    // update (deltaTime: number) {
    //     // [4]
    // }


    on_touch_s() {

        this.ship_js.btn_forward();

    }


    on_touch_off() {
        this.ship_js.off_worward();
    }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.3/manual/zh/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.3/manual/zh/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.3/manual/zh/scripting/life-cycle-callbacks.html
 */
