System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, Node, CCFloat, Vec2, Vec3, UITransformComponent, CameraComponent, _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _temp, _crd, ccclass, property, Joystick;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
      CCFloat = _cc.CCFloat;
      Vec2 = _cc.Vec2;
      Vec3 = _cc.Vec3;
      UITransformComponent = _cc.UITransformComponent;
      CameraComponent = _cc.CameraComponent;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "9afc6eCvXBNVYlf0kcoektu", "Joystick", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("default", Joystick = (_dec = ccclass('Joystick'), _dec2 = property({
        displayName: "canvas下的相机，只拍UI的那个",
        tooltip: "canvas下的相机，只拍UI的那个",
        type: CameraComponent
      }), _dec3 = property({
        displayName: "父节点",
        tooltip: "摇杆中心点和背景的父节点，需要用这个节点来做坐标转换",
        type: UITransformComponent
      }), _dec4 = property({
        displayName: "摇杆背景",
        tooltip: "摇杆背景",
        type: Node
      }), _dec5 = property({
        displayName: "摇杆中心点",
        tooltip: "摇杆中心点",
        type: Node
      }), _dec6 = property({
        displayName: "最大半径",
        tooltip: "摇杆移动的最大半径",
        type: CCFloat
      }), _dec7 = property({
        displayName: "是否禁用摇杆",
        tooltip: "是否禁用摇杆，禁用后摇杆将不能摇动"
      }), _dec(_class = (_class2 = (_temp = /*#__PURE__*/function (_Component) {
        _inheritsLoose(Joystick, _Component);

        function Joystick() {
          var _this;

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this = _Component.call.apply(_Component, [this].concat(args)) || this;

          _initializerDefineProperty(_assertThisInitialized(_this), "camera", _descriptor, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "parent", _descriptor2, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "bg", _descriptor3, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "joystick", _descriptor4, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "max_R", _descriptor5, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "is_forbidden", _descriptor6, _assertThisInitialized(_this));

          _defineProperty(_assertThisInitialized(_this), "angle", 90);

          _defineProperty(_assertThisInitialized(_this), "vector", new Vec2(0, 0));

          return _this;
        }

        var _proto = Joystick.prototype;

        _proto.onLoad = function onLoad() {
          // 绑定事件
          // 因为摇杆中心点很小，如果给摇杆中心点绑定事件玩家将很难控制，摇杆的背景比较大，所以把事件都绑定在背景上是不错的选择，这样体验更好
          // 手指移动
          this.bg.on(Node.EventType.TOUCH_MOVE, this.move, this); // 手指结束

          this.bg.on(Node.EventType.TOUCH_END, this.finish, this); // 手指取消

          this.bg.on(Node.EventType.TOUCH_CANCEL, this.finish, this);
        };

        _proto.update = function update() {
          // 如果角色的移动向量为(0, 0)，就不执行以下代码
          if (this.vector.x == 0 && this.vector.y == 0) {
            return;
          } // 求出角色旋转的角度


          var angle = this.vector_to_angle(this.vector); // 赋值给angle，Player脚本将会获取angle

          this.angle = angle;
        } // 手指移动时调用，移动摇杆专用函数
        ;

        _proto.move = function move(event) {
          // 如果没有禁用摇杆
          if (this.is_forbidden == false) {
            /*
            通过点击屏幕获得的点的坐标是屏幕坐标
            必须先用相机从屏幕坐标转到世界坐标
            再从世界坐标转到节点坐标
             就这个问题折腾了很久
            踩坑踩坑踩坑
            */
            // 获取触点的位置，屏幕坐标
            var point = new Vec2(event.getLocationX(), event.getLocationY()); // 屏幕坐标转为世界坐标

            var world_point = this.camera.screenToWorld(new Vec3(point.x, point.y)); // 世界坐标转节点坐标
            // 将一个点转换到节点 (局部) 空间坐标系，这个坐标系以锚点为原点。

            var pos = this.parent.convertToNodeSpaceAR(new Vec3(world_point.x, world_point.y)); // 如果触点长度小于我们规定好的最大半径

            if (pos.length() < this.max_R) {
              // 摇杆的坐标为触点坐标
              this.joystick.setPosition(pos.x, pos.y);
            } else {
              // 如果不
              // 将向量归一化
              var pos_ = pos.normalize(); // 归一化的坐标 * 最大半径

              var x = pos_.x * this.max_R;
              var y = pos_.y * this.max_R; // 赋值给摇杆

              this.joystick.setPosition(x, y);
            } // 把摇杆中心点坐标，也就是角色移动向量赋值给vector


            this.vector = new Vec2(this.joystick.position.x, this.joystick.position.y);
          } // 如果摇杆被禁用 
          else {
              // 弹回摇杆
              this.finish();
            }
        } // 摇杆中心点弹回原位置专用函数
        ;

        _proto.finish = function finish() {
          // 摇杆坐标和移动向量都设为（0,0）
          this.joystick.position = new Vec3(0, 0);
          this.vector = new Vec2(0, 0);
        } // 角度转弧度
        ;

        _proto.angle_to_radian = function angle_to_radian(angle) {
          // 角度转弧度公式
          // π / 180 * 角度
          // 计算出弧度
          var radian = Math.PI / 180 * angle; // 返回弧度

          return radian;
        } // 弧度转角度
        ;

        _proto.radian_to_angle = function radian_to_angle(radian) {
          // 弧度转角度公式
          // 180 / π * 弧度
          // 计算出角度
          var angle = 180 / Math.PI * radian; // 返回弧度

          return angle;
        } // 角度转向量   
        ;

        _proto.angle_to_vector = function angle_to_vector(angle) {
          // tan = sin / cos
          // 将传入的角度转为弧度
          var radian = this.angle_to_radian(angle); // 算出cos,sin和tan

          var cos = Math.cos(radian); // 邻边 / 斜边

          var sin = Math.sin(radian); // 对边 / 斜边

          var tan = sin / cos; // 对边 / 邻边
          // 结合在一起并归一化

          var vec = new Vec2(cos, sin).normalize(); // 返回向量

          return vec;
        } // 向量转角度
        ;

        _proto.vector_to_angle = function vector_to_angle(vector) {
          // 将传入的向量归一化
          var dir = vector.normalize(); // 计算出目标角度的弧度

          var radian = dir.signAngle(new Vec2(1, 0)); // 把弧度计算成角度

          var angle = -this.radian_to_angle(radian); // 返回角度

          return angle;
        };

        return Joystick;
      }(Component), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "camera", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "parent", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "bg", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "joystick", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "max_R", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return 135;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "is_forbidden", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return false;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=Joystick.js.map